<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>API: example2DWalkingMetabolics.cpp</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script>
<script type="text/javascript" async="async" src="MathJax-2.7.0/MathJax.js"></script>
<link href="doxygen_developer.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="OpenSimLogoWhiteHorizontal_small.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">API
   &#160;<span id="projectnumber">4.4.1-2022-09-05-d4bb9bc34</span>
   </div>
   <div id="projectbrief">For C++ developers</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('example2DWalkingMetabolics_8cpp-example.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">example2DWalkingMetabolics.cpp</div>  </div>
</div><!--header-->
<div class="contents">
<p>This is an example using the MocoTrack tool that also shows how to minimize the total metabolic rate employing the Bhargava2004SmoothedMuscleMetabolics.</p>
<div class="fragment"><div class="line"><span class="comment">/* -------------------------------------------------------------------------- *</span></div>
<div class="line"><span class="comment"> * OpenSim Moco: example2DWalkingMetabolics.cpp                               *</span></div>
<div class="line"><span class="comment"> * -------------------------------------------------------------------------- *</span></div>
<div class="line"><span class="comment"> * Copyright (c) 2017-20 Stanford University and the Authors                  *</span></div>
<div class="line"><span class="comment"> *                                                                            *</span></div>
<div class="line"><span class="comment"> * Author(s): Antoine Falisse                                                 *</span></div>
<div class="line"><span class="comment"> *                                                                            *</span></div>
<div class="line"><span class="comment"> * Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may    *</span></div>
<div class="line"><span class="comment"> * not use this file except in compliance with the License. You may obtain a  *</span></div>
<div class="line"><span class="comment"> * copy of the License at http://www.apache.org/licenses/LICENSE-2.0          *</span></div>
<div class="line"><span class="comment"> *                                                                            *</span></div>
<div class="line"><span class="comment"> * Unless required by applicable law or agreed to in writing, software        *</span></div>
<div class="line"><span class="comment"> * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,          *</span></div>
<div class="line"><span class="comment"> * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.   *</span></div>
<div class="line"><span class="comment"> * See the License for the specific language governing permissions and        *</span></div>
<div class="line"><span class="comment"> * limitations under the License.                                             *</span></div>
<div class="line"><span class="comment"> * -------------------------------------------------------------------------- */</span></div>
<div class="line"> </div>
<div class="line"> </div>
<div class="line"><span class="preprocessor">#include &lt;OpenSim/Moco/MocoGoal/MocoOutputGoal.h&gt;</span></div>
<div class="line"><span class="preprocessor">#include &lt;OpenSim/Moco/osimMoco.h&gt;</span></div>
<div class="line"> </div>
<div class="line"><span class="keyword">using namespace </span><a class="code" href="namespaceOpenSim.html">OpenSim</a>;</div>
<div class="line"> </div>
<div class="line"><span class="comment">// Set a coordinate tracking problem where the goal is to minimize the</span></div>
<div class="line"><span class="comment">// difference between provided and simulated coordinate values and speeds</span></div>
<div class="line"><span class="comment">// as well as to minimize an effort cost (squared controls) and a metabolic</span></div>
<div class="line"><span class="comment">// cost (metabolic energy rate normalized by distance traveled and body mass;</span></div>
<div class="line"><span class="comment">// the metabolics model is based on a smooth approximation of the</span></div>
<div class="line"><span class="comment">// phenomenological model described by Bhargava et al. (2004)). The provided</span></div>
<div class="line"><span class="comment">// data represents half a gait cycle. Endpoint constraints enforce periodicity</span></div>
<div class="line"><span class="comment">// of the coordinate values (except for pelvis tx) and speeds, coordinate</span></div>
<div class="line"><span class="comment">// actuator controls, and muscle activations.</span></div>
<div class="line"><span class="keywordtype">void</span> gaitTrackingMetabolics() {</div>
<div class="line"> </div>
<div class="line">    <span class="keyword">using</span> SimTK::Pi;</div>
<div class="line"> </div>
<div class="line">    MocoTrack track;</div>
<div class="line">    track.setName(<span class="stringliteral">&quot;gaitTrackingMetabolics&quot;</span>);</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// Define the optimal control problem.</span></div>
<div class="line">    <span class="comment">// ===================================</span></div>
<div class="line">    Model baseModel(<span class="stringliteral">&quot;2D_gait.osim&quot;</span>);</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// Add metabolics</span></div>
<div class="line">    Bhargava2004SmoothedMuscleMetabolics* metabolics =</div>
<div class="line">            <span class="keyword">new</span> Bhargava2004SmoothedMuscleMetabolics();</div>
<div class="line">    metabolics-&gt;setName(<span class="stringliteral">&quot;metabolics&quot;</span>);</div>
<div class="line">    metabolics-&gt;set_use_smoothing(<span class="keyword">true</span>);</div>
<div class="line">    metabolics-&gt;addMuscle(<span class="stringliteral">&quot;hamstrings_r&quot;</span>,</div>
<div class="line">            baseModel.getComponent&lt;Muscle&gt;(<span class="stringliteral">&quot;hamstrings_r&quot;</span>));</div>
<div class="line">    metabolics-&gt;addMuscle(<span class="stringliteral">&quot;hamstrings_l&quot;</span>,</div>
<div class="line">            baseModel.getComponent&lt;Muscle&gt;(<span class="stringliteral">&quot;hamstrings_l&quot;</span>));</div>
<div class="line">    metabolics-&gt;addMuscle(<span class="stringliteral">&quot;bifemsh_r&quot;</span>,</div>
<div class="line">            baseModel.getComponent&lt;Muscle&gt;(<span class="stringliteral">&quot;bifemsh_r&quot;</span>));</div>
<div class="line">    metabolics-&gt;addMuscle(<span class="stringliteral">&quot;bifemsh_l&quot;</span>,</div>
<div class="line">            baseModel.getComponent&lt;Muscle&gt;(<span class="stringliteral">&quot;bifemsh_l&quot;</span>));</div>
<div class="line">    metabolics-&gt;addMuscle(<span class="stringliteral">&quot;glut_max_r&quot;</span>,</div>
<div class="line">            baseModel.getComponent&lt;Muscle&gt;(<span class="stringliteral">&quot;glut_max_r&quot;</span>));</div>
<div class="line">    metabolics-&gt;addMuscle(<span class="stringliteral">&quot;glut_max_l&quot;</span>,</div>
<div class="line">            baseModel.getComponent&lt;Muscle&gt;(<span class="stringliteral">&quot;glut_max_l&quot;</span>));</div>
<div class="line">    metabolics-&gt;addMuscle(<span class="stringliteral">&quot;iliopsoas_r&quot;</span>,</div>
<div class="line">            baseModel.getComponent&lt;Muscle&gt;(<span class="stringliteral">&quot;iliopsoas_r&quot;</span>));</div>
<div class="line">    metabolics-&gt;addMuscle(<span class="stringliteral">&quot;iliopsoas_l&quot;</span>,</div>
<div class="line">            baseModel.getComponent&lt;Muscle&gt;(<span class="stringliteral">&quot;iliopsoas_l&quot;</span>));</div>
<div class="line">    metabolics-&gt;addMuscle(<span class="stringliteral">&quot;rect_fem_r&quot;</span>,</div>
<div class="line">            baseModel.getComponent&lt;Muscle&gt;(<span class="stringliteral">&quot;rect_fem_r&quot;</span>));</div>
<div class="line">    metabolics-&gt;addMuscle(<span class="stringliteral">&quot;rect_fem_l&quot;</span>,</div>
<div class="line">            baseModel.getComponent&lt;Muscle&gt;(<span class="stringliteral">&quot;rect_fem_l&quot;</span>));</div>
<div class="line">    metabolics-&gt;addMuscle(<span class="stringliteral">&quot;vasti_r&quot;</span>,</div>
<div class="line">            baseModel.getComponent&lt;Muscle&gt;(<span class="stringliteral">&quot;vasti_r&quot;</span>));</div>
<div class="line">    metabolics-&gt;addMuscle(<span class="stringliteral">&quot;vasti_l&quot;</span>,</div>
<div class="line">            baseModel.getComponent&lt;Muscle&gt;(<span class="stringliteral">&quot;vasti_l&quot;</span>));</div>
<div class="line">    metabolics-&gt;addMuscle(<span class="stringliteral">&quot;gastroc_r&quot;</span>,</div>
<div class="line">            baseModel.getComponent&lt;Muscle&gt;(<span class="stringliteral">&quot;gastroc_r&quot;</span>));</div>
<div class="line">    metabolics-&gt;addMuscle(<span class="stringliteral">&quot;gastroc_l&quot;</span>,</div>
<div class="line">            baseModel.getComponent&lt;Muscle&gt;(<span class="stringliteral">&quot;gastroc_l&quot;</span>));</div>
<div class="line">    metabolics-&gt;addMuscle(<span class="stringliteral">&quot;soleus_r&quot;</span>,</div>
<div class="line">            baseModel.getComponent&lt;Muscle&gt;(<span class="stringliteral">&quot;soleus_r&quot;</span>));</div>
<div class="line">    metabolics-&gt;addMuscle(<span class="stringliteral">&quot;soleus_l&quot;</span>,</div>
<div class="line">            baseModel.getComponent&lt;Muscle&gt;(<span class="stringliteral">&quot;soleus_l&quot;</span>));</div>
<div class="line">    metabolics-&gt;addMuscle(<span class="stringliteral">&quot;tib_ant_r&quot;</span>,</div>
<div class="line">            baseModel.getComponent&lt;Muscle&gt;(<span class="stringliteral">&quot;tib_ant_r&quot;</span>));</div>
<div class="line">    metabolics-&gt;addMuscle(<span class="stringliteral">&quot;tib_ant_l&quot;</span>,</div>
<div class="line">            baseModel.getComponent&lt;Muscle&gt;(<span class="stringliteral">&quot;tib_ant_l&quot;</span>));</div>
<div class="line">    baseModel.addComponent(metabolics);</div>
<div class="line">    baseModel.finalizeConnections();</div>
<div class="line"> </div>
<div class="line">    ModelProcessor modelprocessor = ModelProcessor(baseModel);</div>
<div class="line">    track.setModel(modelprocessor);</div>
<div class="line">    track.setStatesReference(</div>
<div class="line">            TableProcessor(<span class="stringliteral">&quot;referenceCoordinates.sto&quot;</span>) | TabOpLowPassFilter(6));</div>
<div class="line">    track.set_states_global_tracking_weight(30.0);</div>
<div class="line">    track.set_allow_unused_references(<span class="keyword">true</span>);</div>
<div class="line">    track.set_track_reference_position_derivatives(<span class="keyword">true</span>);</div>
<div class="line">    track.set_apply_tracked_states_to_guess(<span class="keyword">true</span>);</div>
<div class="line">    track.set_initial_time(0.0);</div>
<div class="line">    track.set_final_time(0.47008941);</div>
<div class="line">    MocoStudy study = track.initialize();</div>
<div class="line">    MocoProblem&amp; problem = study.updProblem();</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// Goals.</span></div>
<div class="line">    <span class="comment">// =====</span></div>
<div class="line">    <span class="comment">// Symmetry.</span></div>
<div class="line">    <span class="keyword">auto</span>* symmetryGoal = problem.addGoal&lt;MocoPeriodicityGoal&gt;(<span class="stringliteral">&quot;symmetryGoal&quot;</span>);</div>
<div class="line">    Model model = modelprocessor.process();</div>
<div class="line">    model.initSystem();</div>
<div class="line">    <span class="comment">// Symmetric coordinate values (except for pelvis_tx) and speeds.</span></div>
<div class="line">    <span class="keywordflow">for</span> (<span class="keyword">const</span> <span class="keyword">auto</span>&amp; coord : model.getComponentList&lt;Coordinate&gt;()) {</div>
<div class="line">        <span class="keywordflow">if</span> (<a name="a0"></a><a class="code" href="classOpenSim_1_1IO.html#a4258a7782b6f5cd5eec4c6a9dda7025c">IO::EndsWith</a>(coord.getName(), <span class="stringliteral">&quot;_r&quot;</span>)) {</div>
<div class="line">            symmetryGoal-&gt;addStatePair({coord.getStateVariableNames()[0],</div>
<div class="line">                    std::regex_replace(coord.getStateVariableNames()[0],</div>
<div class="line">                            std::regex(<span class="stringliteral">&quot;_r&quot;</span>), <span class="stringliteral">&quot;_l&quot;</span>)});</div>
<div class="line">            symmetryGoal-&gt;addStatePair({coord.getStateVariableNames()[1],</div>
<div class="line">                    std::regex_replace(coord.getStateVariableNames()[1],</div>
<div class="line">                            std::regex(<span class="stringliteral">&quot;_r&quot;</span>), <span class="stringliteral">&quot;_l&quot;</span>)});</div>
<div class="line">        }</div>
<div class="line">        <span class="keywordflow">if</span> (<a class="code" href="classOpenSim_1_1IO.html#a4258a7782b6f5cd5eec4c6a9dda7025c">IO::EndsWith</a>(coord.getName(), <span class="stringliteral">&quot;_l&quot;</span>)) {</div>
<div class="line">            symmetryGoal-&gt;addStatePair({coord.getStateVariableNames()[0],</div>
<div class="line">                    std::regex_replace(coord.getStateVariableNames()[0],</div>
<div class="line">                            std::regex(<span class="stringliteral">&quot;_l&quot;</span>), <span class="stringliteral">&quot;_r&quot;</span>)});</div>
<div class="line">            symmetryGoal-&gt;addStatePair({coord.getStateVariableNames()[1],</div>
<div class="line">                    std::regex_replace(coord.getStateVariableNames()[1],</div>
<div class="line">                            std::regex(<span class="stringliteral">&quot;_l&quot;</span>), <span class="stringliteral">&quot;_r&quot;</span>)});</div>
<div class="line">        }</div>
<div class="line">        <span class="keywordflow">if</span> (!<a class="code" href="classOpenSim_1_1IO.html#a4258a7782b6f5cd5eec4c6a9dda7025c">IO::EndsWith</a>(coord.getName(), <span class="stringliteral">&quot;_l&quot;</span>) &amp;&amp;</div>
<div class="line">                !<a class="code" href="classOpenSim_1_1IO.html#a4258a7782b6f5cd5eec4c6a9dda7025c">IO::EndsWith</a>(coord.getName(), <span class="stringliteral">&quot;_r&quot;</span>) &amp;&amp;</div>
<div class="line">                !<a class="code" href="classOpenSim_1_1IO.html#a4258a7782b6f5cd5eec4c6a9dda7025c">IO::EndsWith</a>(coord.getName(), <span class="stringliteral">&quot;_tx&quot;</span>)) {</div>
<div class="line">            symmetryGoal-&gt;addStatePair({coord.getStateVariableNames()[0],</div>
<div class="line">                    coord.getStateVariableNames()[0]});</div>
<div class="line">            symmetryGoal-&gt;addStatePair({coord.getStateVariableNames()[1],</div>
<div class="line">                    coord.getStateVariableNames()[1]});</div>
<div class="line">        }</div>
<div class="line">    }</div>
<div class="line">    symmetryGoal-&gt;addStatePair({<span class="stringliteral">&quot;/jointset/groundPelvis/pelvis_tx/speed&quot;</span>});</div>
<div class="line">    <span class="comment">// Symmetric coordinate actuator controls.</span></div>
<div class="line">    symmetryGoal-&gt;addControlPair({<span class="stringliteral">&quot;/lumbarAct&quot;</span>});</div>
<div class="line">    <span class="comment">// Symmetric muscle activations.</span></div>
<div class="line">    <span class="keywordflow">for</span> (<span class="keyword">const</span> <span class="keyword">auto</span>&amp; muscle : model.getComponentList&lt;Muscle&gt;()) {</div>
<div class="line">        <span class="keywordflow">if</span> (<a class="code" href="classOpenSim_1_1IO.html#a4258a7782b6f5cd5eec4c6a9dda7025c">IO::EndsWith</a>(muscle.getName(), <span class="stringliteral">&quot;_r&quot;</span>)) {</div>
<div class="line">            symmetryGoal-&gt;addStatePair({muscle.getStateVariableNames()[0],</div>
<div class="line">                    std::regex_replace(muscle.getStateVariableNames()[0],</div>
<div class="line">                            std::regex(<span class="stringliteral">&quot;_r&quot;</span>), <span class="stringliteral">&quot;_l&quot;</span>)});</div>
<div class="line">        }</div>
<div class="line">        <span class="keywordflow">if</span> (<a class="code" href="classOpenSim_1_1IO.html#a4258a7782b6f5cd5eec4c6a9dda7025c">IO::EndsWith</a>(muscle.getName(), <span class="stringliteral">&quot;_l&quot;</span>)) {</div>
<div class="line">            symmetryGoal-&gt;addStatePair({muscle.getStateVariableNames()[0],</div>
<div class="line">                    std::regex_replace(muscle.getStateVariableNames()[0],</div>
<div class="line">                            std::regex(<span class="stringliteral">&quot;_l&quot;</span>), <span class="stringliteral">&quot;_r&quot;</span>)});</div>
<div class="line">        }</div>
<div class="line">    }</div>
<div class="line">    <span class="comment">// Effort. Get a reference to the MocoControlGoal that is added to every</span></div>
<div class="line">    <span class="comment">// MocoTrack problem by default.</span></div>
<div class="line">    MocoControlGoal&amp; effort =</div>
<div class="line">            <span class="keyword">dynamic_cast&lt;</span>MocoControlGoal&amp;<span class="keyword">&gt;</span>(problem.updGoal(<span class="stringliteral">&quot;control_effort&quot;</span>));</div>
<div class="line">    effort.setWeight(0.1);</div>
<div class="line">    <span class="comment">// Metabolics; total metabolic rate includes activation heat rate,</span></div>
<div class="line">    <span class="comment">// maintenance heat rate, shortening heat rate, mechanical work rate, and</span></div>
<div class="line">    <span class="comment">// basal metabolic rate.</span></div>
<div class="line">    <span class="keyword">auto</span>* metGoal = problem.addGoal&lt;MocoOutputGoal&gt;(<span class="stringliteral">&quot;met&quot;</span>, 0.1);</div>
<div class="line">    metGoal-&gt;setOutputPath(<span class="stringliteral">&quot;/metabolics|total_metabolic_rate&quot;</span>);</div>
<div class="line">    metGoal-&gt;setDivideByDisplacement(<span class="keyword">true</span>);</div>
<div class="line">    metGoal-&gt;setDivideByMass(<span class="keyword">true</span>);</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// Bounds.</span></div>
<div class="line">    <span class="comment">// =======</span></div>
<div class="line">    problem.setStateInfo(<span class="stringliteral">&quot;/jointset/groundPelvis/pelvis_tilt/value&quot;</span>,</div>
<div class="line">            {-20 * Pi / 180, -10 * Pi / 180});</div>
<div class="line">    problem.setStateInfo(<span class="stringliteral">&quot;/jointset/groundPelvis/pelvis_tx/value&quot;</span>, {0, 1});</div>
<div class="line">    problem.setStateInfo(</div>
<div class="line">            <span class="stringliteral">&quot;/jointset/groundPelvis/pelvis_ty/value&quot;</span>, {0.75, 1.25});</div>
<div class="line">    problem.setStateInfo(<span class="stringliteral">&quot;/jointset/hip_l/hip_flexion_l/value&quot;</span>,</div>
<div class="line">            {-10 * Pi / 180, 60 * Pi / 180});</div>
<div class="line">    problem.setStateInfo(<span class="stringliteral">&quot;/jointset/hip_r/hip_flexion_r/value&quot;</span>,</div>
<div class="line">            {-10 * Pi / 180, 60 * Pi / 180});</div>
<div class="line">    problem.setStateInfo(</div>
<div class="line">            <span class="stringliteral">&quot;/jointset/knee_l/knee_angle_l/value&quot;</span>, {-50 * Pi / 180, 0});</div>
<div class="line">    problem.setStateInfo(</div>
<div class="line">            <span class="stringliteral">&quot;/jointset/knee_r/knee_angle_r/value&quot;</span>, {-50 * Pi / 180, 0});</div>
<div class="line">    problem.setStateInfo(<span class="stringliteral">&quot;/jointset/ankle_l/ankle_angle_l/value&quot;</span>,</div>
<div class="line">            {-15 * Pi / 180, 25 * Pi / 180});</div>
<div class="line">    problem.setStateInfo(<span class="stringliteral">&quot;/jointset/ankle_r/ankle_angle_r/value&quot;</span>,</div>
<div class="line">            {-15 * Pi / 180, 25 * Pi / 180});</div>
<div class="line">    problem.setStateInfo(<span class="stringliteral">&quot;/jointset/lumbar/lumbar/value&quot;</span>, {0, 20 * Pi / 180});</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// Configure the solver.</span></div>
<div class="line">    <span class="comment">// =====================</span></div>
<div class="line">    MocoCasADiSolver&amp; solver = study.updSolver&lt;MocoCasADiSolver&gt;();</div>
<div class="line">    solver.set_num_mesh_intervals(50);</div>
<div class="line">    solver.set_verbosity(2);</div>
<div class="line">    solver.set_optim_solver(<span class="stringliteral">&quot;ipopt&quot;</span>);</div>
<div class="line">    solver.set_optim_convergence_tolerance(1e-4);</div>
<div class="line">    solver.set_optim_constraint_tolerance(1e-4);</div>
<div class="line">    solver.set_optim_max_iterations(10000);</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// Solve problem.</span></div>
<div class="line">    <span class="comment">// ==============</span></div>
<div class="line">    MocoSolution solution = study.solve();</div>
<div class="line">    <span class="keyword">auto</span> full = <a name="a1"></a><a class="code" href="group__mocoutil.html#ga2a8c0203ebf6babc23168bc4cd76fa68">createPeriodicTrajectory</a>(solution);</div>
<div class="line">    full.write(<span class="stringliteral">&quot;gaitTrackingMetabolics_solution_fullcycle.sto&quot;</span>);</div>
<div class="line">    std::cout &lt;&lt; <span class="stringliteral">&quot;The metabolic cost of transport is: &quot;</span></div>
<div class="line">        &lt;&lt; solution.getObjectiveTerm(<span class="stringliteral">&quot;met&quot;</span>) &lt;&lt; <span class="stringliteral">&quot; [J kg-1 m-1].&quot;</span> &lt;&lt; std::endl;</div>
<div class="line">    study.visualize(solution);</div>
<div class="line"> </div>
<div class="line">}</div>
<div class="line"> </div>
<div class="line"><span class="keywordtype">int</span> main() {</div>
<div class="line">    <span class="keywordflow">try</span> {</div>
<div class="line">        gaitTrackingMetabolics();</div>
<div class="line">    } <span class="keywordflow">catch</span> (<span class="keyword">const</span> std::exception&amp; e) { std::cout &lt;&lt; e.what() &lt;&lt; std::endl; }</div>
<div class="line">    <span class="keywordflow">return</span> EXIT_SUCCESS;</div>
<div class="line">}</div>
<div class="ttc" id="aclassOpenSim_1_1IO_html_a4258a7782b6f5cd5eec4c6a9dda7025c"><div class="ttname"><a href="classOpenSim_1_1IO.html#a4258a7782b6f5cd5eec4c6a9dda7025c">OpenSim::IO::EndsWith</a></div><div class="ttdeci">static bool EndsWith(const std::string &amp;string, const std::string &amp;ending)</div><div class="ttdoc">Determine if string ends with the substring ending.</div></div>
<div class="ttc" id="agroup__mocoutil_html_ga2a8c0203ebf6babc23168bc4cd76fa68"><div class="ttname"><a href="group__mocoutil.html#ga2a8c0203ebf6babc23168bc4cd76fa68">OpenSim::createPeriodicTrajectory</a></div><div class="ttdeci">OSIMMOCO_API MocoTrajectory createPeriodicTrajectory(const MocoTrajectory &amp;halfPeriodTrajectory, std::vector&lt; std::string &gt; addPatterns={&quot;.*pelvis_tx/value&quot;}, std::vector&lt; std::string &gt; negatePatterns={ &quot;.*pelvis_list(?!/value).*&quot;, &quot;.*pelvis_rotation.*&quot;, &quot;.*pelvis_tz(?!/value).*&quot;, &quot;.*lumbar_bending(?!/value).*&quot;, &quot;.*lumbar_rotation.*&quot;}, std::vector&lt; std::string &gt; negateAndShiftPatterns={ &quot;.*pelvis_list/value&quot;, &quot;.*pelvis_tz/value&quot;, &quot;.*lumbar_bending/value&quot;}, std::vector&lt; std::pair&lt; std::string, std::string &gt;&gt; symmetryPatterns={{R&quot;(_r(\/|_|$))&quot;, &quot;_l$1&quot;}, {R&quot;(_l(\/|_|$))&quot;, &quot;_r$1&quot;}})</div><div class="ttdoc">Convert a trajectory covering half the period of a symmetric motion into a trajectory over the full p...</div></div>
<div class="ttc" id="anamespaceOpenSim_html"><div class="ttname"><a href="namespaceOpenSim.html">OpenSim</a></div><div class="ttdoc">The Moco interface is contained within the OpenSim namespace.</div><div class="ttdef"><b>Definition:</b> ActivationCoordinateActuator.h:30</div></div>
</div><!-- fragment --> </div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="footer">Generated on Mon Sep 5 2022 20:49:01 for API by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.0 </li>
  </ul>
</div>
</body>
</html>
